'-----------------------------------------------------
'Ansteuereungsbeispiel fr CC2Net-RAM-Device HS bzw.
'CC2Net-RAM-Interface IC + PCF-LCD-Interface-Platine
'CCTools 2002 cctools.hs-control.de (21.08.2002)
'----------------------------------------------------

define cmd byte[2]
define addr word[2]
define LCDLight Bit[192]

'LCD-Einsprung-Adressen
define LCDcmd &h1af : define LCDcmd8 &h1b5 :define LCDchar &h1bd
define prnLCD &h1dd
define PCF 64 ' Adresse des LCD-Interfaces. Kann auch statisch sein(z.B. bei mehreren LCDs)

'RAM-Einsprung-Adressen & Variablen & Konstanten
define READbyte &h11f : define READword &h125
define WRITEbyte &h115 : define WRITEword &h10d
define REDPorts &h101 : define RAMinit &h197
define deselect &b00111110 'fr CC2Net-RAM-Interface IC
'define deselect &b00100110 'fr CC2Net-RAM-Device HS
define control Byte[1] 'Register fr I/O-Ports, CS-Leitungen und Bit17(RAM-Addr)
define bit16 Bit[1]
define CS1 Bit[2] 'Chip-Select: Lo=selected, Hi=deselected
define CS2 Bit[3]
define CS3 Bit[4] 'Bei RAM-Device HS I/O 1
define CS4 Bit[5] 'Bei RAM-Device HS I/O 2
define IO1 Bit[7] 'Bei RAM-Device HS I/O 3
define IO2 Bit[8] 'Bei RAM-Device HS I/O 4

'ASCII fr LCD
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD


LCDLight=On

gosub LCD_Init
#loop
gosub LCD_CLS
sys prnLCD,LCDLight,0,PCF : print "CCTools (c)2002";
cmd=line2 : gosub LCD_CMD
sys prnLCD,LCDLight,0,PCF : print "PCF_LCD";
cmd=line3 : gosub LCD_CMD
sys prnLCD,LCDLight,0,PCF : print "CC2Net-RAM-Dev.";
pause 50

gosub LCD_CLS
sys prnLCD,LCDLight,0,PCF : print "Init...";

gosub RAM_Init
pause 5

gosub LCD_CLS
sys prnLCD,LCDLight,0,PCF : print "Write...";

CS1=0 'RAM 1 selectieren
'ber CS1 bis 4 wird der RAM-Baustein ausgewhlt
'CSx = On od. -1  = Baustein nicht ausgewhlt !
'CSx = Off od. 0  = Baustein ist ausgewhlt !
'Bit16 = On /OF bzw. 0 / -1 = 17tes Adressbit
'der RAM-Bausteine.
'Bit0 bis Bit15 werden mit sys-Aufruf bergeben(addr)


'RAM Beschreiben mit Adresswert
for addr=0 to 512 step 2
 sys WRITEword,not addr,addr
next

gosub LCD_CLS
sys prnLCD,LCDLight,0,PCF : print "Read...";

'514 Werte aus dem RAM-Lesen und an der ser.Schnittstelle
'ausgeben
for addr = 0 to 512 step 2
 print read_word
next


cmd=line4 : gosub LCD_CMD
sys prnLCD,LCDLight,0,PCF : print "Ready";

gosub RAM_deselect

end


'----RAM-Funktionen--------------------------
#RAM_Init
control=&hFE
sys RAMinit,-1,0
return

#READ_byte
sys READbyte,not addr,0
return

#READ_word
sys READword,not addr,0
return

#RAM_Deselect
control=control or deselect
sys WRITEbyte,0,0
return

'Byte schreiben:
'sys WRITEbyte,not addr,Wert

'Word schreiben:
'sys WRITEword,not addr,Wert
'Beim Schreiben von Words mu darauf geachtet
'werden, da nur gerade Adressen angegeben werden
'knnen !


'----LCD-Funktionen--------------------------
'Zahlausgaben
#LCD_Zahl3 ' 3 stellige Zahl ausgeben
if cmd > 99 then sys LCDchar,LCDLight,(cmd/100)+&h30,PCF else sys LCDchar,LCDLight,&h20,PCF
#LCD_Zahl2 ' 2 stellige Zahl ausgeben
if cmd > 9 then sys LCDchar,LCDLight,((cmd/10) mod 10)+&h30,PCF else sys LCDchar,LCDLight,&h20,PCF
#LCD_Zahl1 '1 stellige Zahl ausgeben
sys LCDchar,LCDLight,(cmd mod 10)+&h30,PCF
return
#LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
sys LCDchar,LCDLight,((cmd/100) mod 10)+&h30,PCF
#LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
sys LCDchar,LCDLight,((cmd/10) mod 10)+&h30,PCF
goto LCD_Zahl1

#LCD_CLS 'LCD lschen
sys LCDcmd,LCDLight,&b00000001,PCF
return
#LCD_CMD 'Kommando senden
sys LCDcmd,LCDLight,cmd,PCF
return
#LCD_Char 'Zeichen senden
sys LCDchar,LCDLight,cmd,PCF
return
#LCD_Init 'LCD_Initialisieren
sys LCDcmd,0,&b00111000,PCF
sys LCDcmd8,0,&b00100000,PCF
sys LCDcmd,0,&b00101000,PCF
sys LCDcmd,0,&b00001110,PCF
sys LCDcmd,0,&b00000001,PCF
sys LCDcmd,0,&b00000110,PCF
return
#setPCFLight
sys LCDcmd,LCDLight,0,PCF
return

syscode "ri2cplcd.s19" 'Nur einmal laden, dann auskommentieren !
